/*	mousdemo.c  Turbo Technix magazine  						*/

/* includes */
#include <stdio.h>
#include <dos.h>
#include <mouse.inc>

/* constants */
#define HARDWARE    1
#define SOFTWARE    0
#define LEFT        0
#define RIGHT		1
#define ROMBIOS	int86(0x10,&inreg,&outreg)

/* local functions */
void clrScr(void);
void gotoxy (int col, int row);

/*********************************/
main()
{
resetRec *theMouse;
locRec *its;
int col,row;
char input[80];

	clrScr();
	theMouse = mReset();
	if (theMouse->exists)
	{
		puts("Software Mouse Cursor:");
		printf("Demo of a mouse with %d buttons\n",theMouse->nButtons);
		puts("Move the mouse around and click the left button");
		puts("click the right button for a hardware demo\n");
		mTextCursor (SOFTWARE,0x0000,0x0718);
		mShow();
		do {
			its = mReleased(LEFT);
			if (its->opCount >0) {
				mHide();
				printf("\nMouse is at col %d, row %d",its->column,its->row);
				mShow();
			}
			its = mReleased(RIGHT);
		} while (its->opCount ==0);

		clrScr();
		puts("Hardware Cursor:");
		puts("Move the mouse, click the left button");
		puts("type something and press enter");
		puts("click right button to end demo");
		theMouse = mReset();
		mTextCursor (HARDWARE,2,5);
		mShow();
		do {
			its = mReleased(LEFT);
			if(its->opCount>0){
				col = its->column/8;
				row = its->row/8;
				gotoxy(col,row);
				putchar('?');
				gets(input);
				mMoveto(its->column,its->row);
			}
			its = mReleased(RIGHT);
		} while(its->opCount == 0);

		mTextCursor (HARDWARE,6,7);
		mReset();
		clrScr();
	} else
	  puts("mouse not present on system ");
}


void clrScr(void)
{
/*	struct REGS inreg,outreg;  */
	inreg.h.ah = 0x0F;
	ROMBIOS;
	inreg.h.al = outreg.h.al;
	inreg.h.ah = 0;
	ROMBIOS;
}


void gotoxy(int col, int row)
{
/*	struct REGS inreg,outreg;*/
	inreg.h.ah = 2;
	inreg.h.bh = 0;
	inreg.h.dh = row;
	inreg.h.dl = col;
	ROMBIOS;
}